[R] bibliothèque quantreg - dépendances (résolu)

Mise à jour / Création /debug de paquetages
Répondre
Thomasb
Daikyu
Messages : 78
Inscription : dim. 28 avr. 2019, 14:49

[R] bibliothèque quantreg - dépendances (résolu)

Message par Thomasb » sam. 11 mai 2019, 19:18

Bonjour,
Il me faudrait quantreg, mais les dépendances r-matrixmodels et rsparsem semblent ne pas exister : https://aur.archlinux.org/packages/r-sparsem/
Dernière modification par Thomasb le dim. 12 mai 2019, 16:10, modifié 1 fois.

laurent85
Chu Ko Nu
Messages : 360
Inscription : mar. 16 oct. 2018, 21:05

Re: [R] : bibliothèque quantreg - dépendances

Message par laurent85 » sam. 11 mai 2019, 20:17

Bonjour,
Tu peux toujours installer les dépendances manuellement et modifier le PKGBUILD dans ce sens. Tu sais comment faire ?

Edition:
Le PKGBUILD n'a pas que les dépendances manquantes, la version des sources téléchargées n'existe plus.
Ce sont des bibliothèques, le plus simple est encore de les installer manuellement, quantreg compris.

Code : Tout sélectionner

sudo pacman --needed -S r base-devel gcc-fortran
wget https://cran.r-project.org/src/contrib/SparseM_1.77.tar.gz
wget https://cran.r-project.org/src/contrib/MatrixModels_0.4-1.tar.gz
wget https://cran.r-project.org/src/contrib/quantreg_5.38.tar.gz
sudo R CMD INSTALL SparseM_1.77.tar.gz
sudo R CMD INSTALL MatrixModels_0.4-1.tar.gz
sudo R CMD INSTALL quantreg_5.38.tar.gz
ls /usr/lib/R/library

hopimet
Elfe
Messages : 941
Inscription : mer. 14 mars 2012, 22:48

Re: [R] : bibliothèque quantreg - dépendances

Message par hopimet » dim. 12 mai 2019, 00:01

Salut,

Pourquoi installer quantreg depuis AUR ?

Il suffit de lancer R en console, ou rstudio si tu utilises cet IDE (que je conseille vivement), et de faire :

Code : Tout sélectionner

install.packages("quantreg")
C'est de cette façon que tous les paquets de r doivent être installé.

Thomasb
Daikyu
Messages : 78
Inscription : dim. 28 avr. 2019, 14:49

Re: [R] : bibliothèque quantreg - dépendances

Message par Thomasb » dim. 12 mai 2019, 01:04

hopimet a écrit :
dim. 12 mai 2019, 00:01
Pourquoi installer quantreg depuis AUR ? Il suffit de lancer R en console
Ça ne marchait pas

laurent85 a écrit :
sam. 11 mai 2019, 20:17
Le PKGBUILD n'a pas que les dépendances manquantes, la version des sources téléchargées n'existe plus.
Ward Segers m'a répondu que c'est réglé : l'autre contributeur, Alex Branham, avait effacé son compte.

[Edit]: Alex Braham m'a répondu aussi, il pensait que les paquetages seraient 'orphaned' mais pas effacés.
Dernière modification par Thomasb le dim. 12 mai 2019, 09:48, modifié 3 fois.

hopimet
Elfe
Messages : 941
Inscription : mer. 14 mars 2012, 22:48

Re: [R] : bibliothèque quantreg - dépendances

Message par hopimet » dim. 12 mai 2019, 01:55

Qu'est ce qui ne marche pas avec install.packages ?
Tu peux donner les retours de la console r ?

J'ai quantreg installé sur mes différentes machines sans problème.

laurent85
Chu Ko Nu
Messages : 360
Inscription : mar. 16 oct. 2018, 21:05

Re: [R] : bibliothèque quantreg - dépendances

Message par laurent85 » dim. 12 mai 2019, 02:07

Thomasb a écrit :
dim. 12 mai 2019, 01:04
Ward Segers m'a répondu que c'est réglé : l'autre contributeur, Alex Branham, avait effacé sont compte.
Pas tout à fait, seulement pour les dépendances, r-quantreg d'AUR est toujours cassé. Les sources 5.36 ne sont plus sur le serveur. Il faut mettre à jour PKGBUILD à la version 5.38. Je l'ai signalé sur AUR.

Thomasb
Daikyu
Messages : 78
Inscription : dim. 28 avr. 2019, 14:49

Re: [R] : bibliothèque quantreg - dépendances

Message par Thomasb » dim. 12 mai 2019, 09:23

hopimet a écrit :
dim. 12 mai 2019, 01:55
Tu peux donner les retours de la console r ?
Le dernier message d'erreur :

Code : Tout sélectionner

ERROR: dependency ‘SparseM’ is not available for package ‘quantreg’
* removing ‘/home/user/R/x86_64-pc-linux-gnu-library/3.6/quantreg’

hopimet
Elfe
Messages : 941
Inscription : mer. 14 mars 2012, 22:48

Re: [R] : bibliothèque quantreg - dépendances

Message par hopimet » dim. 12 mai 2019, 10:58

Il faudrait un peu plus de détails.

Manifestement c'est SparseM qui manque car quantreg n'arrive pas à l'installer en tant que dépendance. Il est possible quel SparseM ne compile pas car une dépendance sur le système manque pour son installation dans r, et c'est probablement gcc-fortran qu'il faut d'abord installer (beaucoup de paquets de r en ont besoin).

Peux tu donner le retour de install.packages("SparseM") ?

Et vérifier que gcc-fortran est bien installé sur ta machine. Sinon, en concole "linux" : sudo pacman -S gcc-fortran puis tu relances l'installation de quantreg en console "r".

PS : pour tous les modules r que j'utilise, sur plusieurs machines, je n'ai jamais eu besoin de recourir à AUR. Quand tu as un soucis comme ça, c'est en général lié un problème de compilation (bien regarder l'intégralité du message d'erreur, avant les 2 dernières lignes indiquant que ça n'a pas marché, en général dans les 10-15 lignes plus haut tu as des précisions sur le problème) car quelque chose manque sur ton système, le plus souvent un compilateur ou un front-end.

Thomasb
Daikyu
Messages : 78
Inscription : dim. 28 avr. 2019, 14:49

Re: [R] : bibliothèque quantreg - dépendances

Message par Thomasb » dim. 12 mai 2019, 11:06

hopimet a écrit :
dim. 12 mai 2019, 10:58
Il faudrait un peu plus de détails.

L'installation manuelle de Laurent a fonctionné, donc je n'ai plus de messages d'erreur.
Pour désinstaller les paquetages il faut faire :

Code : Tout sélectionner

sudo R CMD UNINSTALL SparseM_1.77.tar.gz
sudo R CMD UNINSTALL MatrixModels_0.4-1.tar.gz
sudo R CMD UNINSTALL quantreg_5.38.tar.gz
?

hopimet
Elfe
Messages : 941
Inscription : mer. 14 mars 2012, 22:48

Re: [R] : bibliothèque quantreg - dépendances

Message par hopimet » dim. 12 mai 2019, 12:04

Dommage que tu ne répondes pas à mes questions.

Cette méthode d'installation n'est pas orthodoxe. Il est préférable d'utiliser les dépôt r-cran en passant directement les commandes d'installation depuis la console de r.

Et pour désinstaller il vaut mieux faire (toujours depuis la console de r) : remove.packages() (en précisant les paquets à retirer).

Pour mettre à jour les modules : update.packages()

Cette méthode évite à l'avenir le genre de problème que tu as rencontré avec de PKGBUILD d'AUR non à jour ou plus maintenus. De plus les dépôts officiel de r-cran sont plus sécurisés qu'un PKGBUILD. Enfin si un module n'est plus à jour cela peut bloquer l'installation d'autre modules qui en dépendent alors qu'avec install.packages et update.packages les mises à jours se feront seules.

Enfin, c'est toi qui voit...

Thomasb
Daikyu
Messages : 78
Inscription : dim. 28 avr. 2019, 14:49

Re: [R] : bibliothèque quantreg - dépendances

Message par Thomasb » dim. 12 mai 2019, 12:21

hopimet a écrit :
dim. 12 mai 2019, 12:04
Enfin, c'est toi qui voit...

Ce n'est pas Windows :

Code : Tout sélectionner

> remove.packages("quantreg")
Removing package from ‘/home/user/R/x86_64-pc-linux-gnu-library/3.6’
(as ‘lib’ is unspecified)

hopimet
Elfe
Messages : 941
Inscription : mer. 14 mars 2012, 22:48

Re: [R] : bibliothèque quantreg - dépendances

Message par hopimet » dim. 12 mai 2019, 12:26

Quel rapport avec Windows ?

Thomasb
Daikyu
Messages : 78
Inscription : dim. 28 avr. 2019, 14:49

Re: [R] : bibliothèque quantreg - dépendances

Message par Thomasb » dim. 12 mai 2019, 12:32

hopimet a écrit :
dim. 12 mai 2019, 12:26
Quel rapport avec Windows ?
Si ça peut servir à trouver la source du problème, je peux désinstaller les paquetages. Sous Windows, je ne suis pas sûr que j'aurais pris le risque.

Donc

Code : Tout sélectionner

sudo R CMD UNINSTALL SparseM_1.77.tar.gz
sudo R CMD UNINSTALL MatrixModels_0.4-1.tar.gz
sudo R CMD UNINSTALL quantreg_5.38.tar.gz
?

La désinstallation via la console R répond : "[...] (as 'lib' is unspecified)"

hopimet
Elfe
Messages : 941
Inscription : mer. 14 mars 2012, 22:48

Re: [R] : bibliothèque quantreg - dépendances

Message par hopimet » dim. 12 mai 2019, 12:49

Franchement je ne comprends pas ton histoire de "risque". Pour info je n'utilises pas Windows.
Je t'indique simplement la méthode officielle pour installer/désinstaller proprement des modules sous r. L'installation manuelle telle que tu l'as faite est beaucoup plus fastidieuse, gère mal les dépendances et ne vérifie pas si le module pourra être chargé par : library(module).
Thomasb a écrit :
dim. 12 mai 2019, 12:32
La désinstallation via la console R répond : "[...] (as 'lib' is unspecified)"
Et ?
Le problème avec ta méthode c'est que tu risques d'avoir plusieurs versions installées du même paquet (donc potentiellement le b*rdel). Du coup r demande laquelle il faut désinstaller.

help(remove.packages) pour plus d'infos.

Ça fait longtemps que tu utilises r ?

Thomasb
Daikyu
Messages : 78
Inscription : dim. 28 avr. 2019, 14:49

Re: [R] : bibliothèque quantreg - dépendances

Message par Thomasb » dim. 12 mai 2019, 12:53

hopimet a écrit :
dim. 12 mai 2019, 12:49
Et ?
Si tu veux, j'essaie de désinstaller les paquetages manuellement et de relancer l'installation via la console R ?

hopimet a écrit :
dim. 12 mai 2019, 12:49
Ça fait longtemps que tu utilises r ?
Les paquetages, moins de dix jours...

hopimet
Elfe
Messages : 941
Inscription : mer. 14 mars 2012, 22:48

Re: [R] : bibliothèque quantreg - dépendances

Message par hopimet » dim. 12 mai 2019, 13:16

Bah oui. Désinstalle manuellement et fait ce que je t'ai dit plus haut.

Commence par vérifier si gcc-fortran est installé sur ton système (comme je te l'ai indiqué : sudo pacman -S gcc-fortran). Ensuite, sous r, tu installes SparseM comme demandé : install.packages("SparseM") et tu dis ce qui se passe.

Thomasb
Daikyu
Messages : 78
Inscription : dim. 28 avr. 2019, 14:49

Re: [R] : bibliothèque quantreg - dépendances

Message par Thomasb » dim. 12 mai 2019, 13:47

  1. hopimet a écrit :
    dim. 12 mai 2019, 13:16
    Désinstalle manuellement
    En fait, les commandes sont :

    Code : Tout sélectionner

    sudo R CMD REMOVE SparseM
    sudo R CMD REMOVE MatrixModels
    sudo R CMD REMOVE quantreg
    
  2. hopimet a écrit :
    dim. 12 mai 2019, 13:16
    Commence par vérifier si gcc-fortran est installé sur ton système (comme je te l'ai indiqué : sudo pacman -S gcc-fortran).
    Laurent me les avait fait installer :

    Code : Tout sélectionner

    sudo pacman -S gcc-fortran
    warning: gcc-fortran-8.3.0-1 is up to date -- reinstalling
    resolving dependencies...
    looking for conflicting packages...
    
    Packages (1) gcc-fortran-8.3.0-1
    
    Total Installed Size:  27,08 MiB
    Net Upgrade Size:       0,00 MiB
    
  3. hopimet a écrit :
    dim. 12 mai 2019, 13:16
    Ensuite, sous r, tu installes SparseM comme demandé : install.packages("SparseM") et tu dis ce qui se passe.
    Ce devait être gcc-fortran, il n'y a plus d'erreur :

    Code : Tout sélectionner

    Installing package into ‘/home/user/R/x86_64-pc-linux-gnu-library/3.6’
    (as ‘lib’ is unspecified)
    --- Please select a CRAN mirror for use in this session ---
    trying URL 'https://cran.biotools.fr/src/contrib/SparseM_1.77.tar.gz'
    Content type 'application/x-gzip' length 756317 bytes (738 KB)
    ==================================================
    downloaded 738 KB
    
    * installing *source* package ‘SparseM’ ...
    ** package ‘SparseM’ successfully unpacked and MD5 sums checked
    ** using staged installation
    ** libs
    gfortran  -fpic  -g -O2  -c bckslv.f -o bckslv.o
    gfortran  -fpic  -g -O2  -c chol.f -o chol.o
    gfortran  -fpic  -g -O2  -c chol2csr.f -o chol2csr.o
    gfortran  -fpic  -g -O2  -c cholesky.f -o cholesky.o
    gfortran  -fpic  -g -O2  -c csr.f -o csr.o
    gfortran  -fpic  -g -O2  -c extract.f -o extract.o
    gcc -I"/usr/include/R/" -DNDEBUG   -D_FORTIFY_SOURCE=2  -fpic  -march=x86-64 -mtune=generic -O2 -pipe -fstack-protector-strong -fno-plt  -c init.c -o init.o
    gfortran  -fpic  -g -O2  -c sparskit.f -o sparskit.o
    gfortran  -fpic  -g -O2  -c subscr.f -o subscr.o
    gcc -shared -L/usr/lib64/R/lib -Wl,-O1,--sort-common,--as-needed,-z,relro,-z,now -o SparseM.so bckslv.o chol.o chol2csr.o cholesky.o csr.o extract.o init.o sparskit.o subscr.o -lgfortran -lm -lquadmath -L/usr/lib64/R/lib -lR
    installing to /home/user/R/x86_64-pc-linux-gnu-library/3.6/00LOCK-SparseM/00new/SparseM/libs
    ** R
    ** data
    ** demo
    ** inst
    ** byte-compile and prepare package for lazy loading
    Creating a generic function for ‘diag’ from package ‘base’ in package ‘SparseM’
    Creating a generic function for ‘diag<-’ from package ‘base’ in package ‘SparseM’
    Creating a generic function for ‘norm’ from package ‘base’ in package ‘SparseM’
    Creating a new generic function for ‘backsolve’ in package ‘SparseM’
    Creating a generic function for ‘forwardsolve’ from package ‘base’ in package ‘SparseM’
    Creating a generic function for ‘model.response’ from package ‘stats’ in package ‘SparseM’
    ** help
    *** installing help indices
    ** building package indices
    ** installing vignettes
    ** testing if installed package can be loaded from temporary location
    ** checking absolute paths in shared objects and dynamic libraries
    ** testing if installed package can be loaded from final location
    ** testing if installed package keeps a record of temporary installation path
    * DONE (SparseM)
    
    The downloaded source packages are in
    	‘/tmp/Rtmpx4JWG4/downloaded_packages’
    
  4. L'installation de quantreg avec les dépendances a une erreur sur le paquetage 'rgl' :

    Code : Tout sélectionner

    * DONE (akima)
    * installing *source* package ‘rgl’ ...
    ** package ‘rgl’ successfully unpacked and MD5 sums checked
    ** using staged installation
    checking for gcc... gcc
    checking whether the C compiler works... yes
    checking for C compiler default output file name... a.out
    checking for suffix of executables... 
    checking whether we are cross compiling... no
    checking for suffix of object files... o
    checking whether we are using the GNU C compiler... yes
    checking whether gcc accepts -g... yes
    checking for gcc option to accept ISO C89... none needed
    checking how to run the C preprocessor... gcc -E
    checking for gcc... (cached) gcc
    checking whether we are using the GNU C compiler... (cached) yes
    checking whether gcc accepts -g... (cached) yes
    checking for gcc option to accept ISO C89... (cached) none needed
    checking for libpng-config... yes
    configure: using libpng-config
    configure: using libpng dynamic linkage
    checking for X... libraries , headers 
    checking GL/gl.h usability... yes
    checking GL/gl.h presence... yes
    checking for GL/gl.h... yes
    checking GL/glu.h usability... no
    checking GL/glu.h presence... no
    checking for GL/glu.h... no
    configure: error: missing required header GL/glu.h
    ERROR: configuration failed for package ‘rgl’
    * removing ‘/home/user/R/x86_64-pc-linux-gnu-library/3.6/rgl’
    * installing *source* package ‘logspline’ ...
    
    
    (...)
    
    
    * DONE (quantreg)
    
    The downloaded source packages are in
    	‘/tmp/Rtmpx4JWG4/downloaded_packages’
    Warning message:
    In install.packages("quantreg", dependencies = TRUE) :
      installation of package ‘rgl’ had non-zero exit status
    

    mais le chargement de la bibliothèque marche :

    Code : Tout sélectionner

    > library(quantreg)
    Loading required package: SparseM
    
    Attaching package: ‘SparseM’
    
    The following object is masked from ‘package:base’:
    
        backsolve
    

hopimet
Elfe
Messages : 941
Inscription : mer. 14 mars 2012, 22:48

Re: [R] : bibliothèque quantreg - dépendances

Message par hopimet » dim. 12 mai 2019, 14:21

C'est mieux.
Pour rgl le message informatif est le suivant :
configure: error: missing required header GL/glu.h
Il semble qu'il ne trouve pas glu.h. Est-ce que glu est installé sur ton système : sudo pacman -S glu

Puis tu relances, sous r, l'installation de rgl : install.packages("rgl")

Thomasb
Daikyu
Messages : 78
Inscription : dim. 28 avr. 2019, 14:49

Re: [R] : bibliothèque quantreg - dépendances

Message par Thomasb » dim. 12 mai 2019, 15:02

hopimet a écrit :
dim. 12 mai 2019, 14:21
Puis tu relances

Impeccable :

Code : Tout sélectionner

* DONE (quantreg)

The downloaded source packages are in
	‘/tmp/RtmpqhOamy/downloaded_packages’

hopimet
Elfe
Messages : 941
Inscription : mer. 14 mars 2012, 22:48

Re: [R] : bibliothèque quantreg - dépendances

Message par hopimet » dim. 12 mai 2019, 15:23

Super !

Comme quoi il faut toujours lire attentivement les messages en console.
Tu peux passer ton titre en Résolu. :bravo:

Et n'hésite pas si tu as besoin d'autres conseil pour r. Comme je t'avais dit au début, rstudio (dans AUR) est un excellent IDE pour utiliser r. Je te conseille de le tester.

Répondre